﻿Public Class Form1
    Dim _iRowCount As Integer
    Dim _iColumnCount As Integer
    Private Sub FpSpread1_CellClick(sender As System.Object, e As FarPoint.Win.Spread.CellClickEventArgs) Handles FpSpread1.CellClick
        Dim sum As [Double] = 0
        Dim AvgCount As Integer = 0
        Dim Count As Integer = 0
        If e.RowHeader = True Then
            'Calculate the Sum of the Selection corresponding row
            For i As Integer = 0 To FpSpread1.ActiveSheet.GetLastNonEmptyColumn(FarPoint.Win.Spread.NonEmptyItemFlag.Data)
                Try
                    If FpSpread1.ActiveSheet.Cells(e.Row, i).Text <> String.Empty Then
                        sum = sum + [Double].Parse(FpSpread1.ActiveSheet.Cells(e.Row, i).Text)
                        AvgCount = AvgCount + 1
                        Count = Count + 1
                    End If
                Catch
                    If FpSpread1.ActiveSheet.Cells(e.Row, i).Text <> String.Empty Then
                        Count = Count + 1
                    End If
                End Try
            Next
        ElseIf e.ColumnHeader = True Then
            'Calculate the Sum of the Selection corresponding column
            For i As Integer = 0 To FpSpread1.ActiveSheet.GetLastNonEmptyRow(FarPoint.Win.Spread.NonEmptyItemFlag.Data)
                Try
                    If FpSpread1.ActiveSheet.Cells(i, e.Column).Text <> String.Empty Then
                        sum = sum + [Double].Parse(FpSpread1.ActiveSheet.Cells(i, e.Column).Text)
                        AvgCount = AvgCount + 1
                        Count = Count + 1
                    End If
                Catch
                    If FpSpread1.ActiveSheet.Cells(i, e.Column).Text <> String.Empty Then
                        Count = Count + 1
                    End If
                End Try
            Next
        End If
       
        'Display Sum, Avg and Count
        LblSum.Text = "Sum : " + sum.ToString()
        If AvgCount > 0 Then
            LblAvg.Text = "Average :" + (sum / AvgCount).ToString()
        Else
            LblAvg.Text = "Average : 0"
        End If
        LblCount.Text = "count :" + Count.ToString()
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        _iRowCount = FpSpread1.ActiveSheet.RowCount
        _iColumnCount = FpSpread1.ActiveSheet.ColumnCount
        FpSpread1.ActiveSheet.SelectionPolicy = FarPoint.Win.Spread.Model.SelectionPolicy.Range
        For i As Integer = 0 To 9
            For j As Integer = 0 To 9
                FpSpread1.ActiveSheet.Cells(i, j).Text = i.ToString() + "" + j.ToString()
            Next
        Next
      LblSum.Text = "Sum : 0"
    End Sub

    Private Sub FpSpread1_SelectionChanging(sender As System.Object, e As FarPoint.Win.Spread.SelectionChangingEventArgs) Handles FpSpread1.SelectionChanging
        'Calculate the Sum of the Selection
        Dim sum As [Double] = 0
        Dim AvgCount As Integer = 0
        Dim Count As Integer = 0
        'When selection perform using row header
        If e.Range.Column = -1 Then
            For i As Integer = e.Range.Row To e.Range.Row + (e.Range.RowCount - 1)
                For j As Integer = 0 To FpSpread1.ActiveSheet.GetLastNonEmptyColumn(FarPoint.Win.Spread.NonEmptyItemFlag.Data)
                    Try
                        If FpSpread1.ActiveSheet.Cells(i, j).Text <> String.Empty Then

                            sum = sum + [Double].Parse(FpSpread1.ActiveSheet.Cells(i, j).Text)
                            AvgCount = AvgCount + 1
                            Count = Count + 1
                        End If
                    Catch
                        If FpSpread1.ActiveSheet.Cells(i, j).Text <> String.Empty Then
                            Count = Count + 1
                        End If
                    End Try
                Next
            Next
            ' Selection perform using Column Header
        ElseIf e.Range.Row = -1 Then
            For i As Integer = 0 To FpSpread1.ActiveSheet.GetLastNonEmptyRow(FarPoint.Win.Spread.NonEmptyItemFlag.Data)
                For j As Integer = e.Range.Column To e.Range.Column + (e.Range.ColumnCount - 1)
                    Try
                        If FpSpread1.ActiveSheet.Cells(i, j).Text <> String.Empty Then

                            sum = sum + [Double].Parse(FpSpread1.ActiveSheet.Cells(i, j).Text)
                            AvgCount = AvgCount + 1
                            Count = Count + 1
                        End If
                    Catch
                        If FpSpread1.ActiveSheet.Cells(i, j).Text <> String.Empty Then
                            Count = Count + 1
                        End If
                    End Try
                Next
            Next
        Else

            For i As Integer = e.Range.Row To e.Range.Row + (e.Range.RowCount - 1)
                For j As Integer = e.Range.Column To e.Range.Column + (e.Range.ColumnCount - 1)
                    Try
                        If FpSpread1.ActiveSheet.Cells(i, j).Text <> String.Empty Then

                            sum = sum + [Double].Parse(FpSpread1.ActiveSheet.Cells(i, j).Text)
                            AvgCount = AvgCount + 1
                            Count = Count + 1
                        End If
                    Catch
                        If FpSpread1.ActiveSheet.Cells(i, j).Text <> String.Empty Then
                            Count = Count + 1
                        End If
                    End Try
                Next
            Next
        End If
        'Display Sum, Avg and Count
        LblSum.Text = "Sum : " + sum.ToString()
        If AvgCount > 0 Then
            LblAvg.Text = "Average :" + (sum / AvgCount).ToString()
        Else
            LblAvg.Text = "Average : 0"
        End If
        LblCount.Text = "count :" + Count.ToString()


    End Sub
End Class
